=== debian/changelog ===
cmark (0.26.1-1) unstable; urgency=low

  * Initial release (closes: #833682)

 -- Peter Eisentraut <petere@debian.org>  Mon, 05 Sep 2016 01:53:18 +0000
