=== debian/control ===
Source: cmark
Build-Depends: cmake, debhelper (>= 9), python3
Homepage: https://github.com/jgm/cmark
Maintainer: Peter Eisentraut <petere@debian.org>
Priority: optional
Section: text
Standards-Version: 3.9.8

Package: cmark
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: CommonMark parsing and rendering program
 cmark is the C reference implementation of CommonMark, a rationalized
 version of Markdown syntax with a spec.  This package provides a
 command-line program (cmark) for parsing and rendering CommonMark
 documents.
