=== debian/changelog ===
cmark (0.28.3-1) unstable; urgency=low

  * New upstream release (closes: #892815)
  * Update standards version
  * Fix some lintian warnings

 -- Peter Eisentraut <petere@debian.org>  Sun, 27 May 2018 23:55:25 +0000

cmark (0.26.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add libcmark* packages (Closes: #840727)
  * Switch to debhelper 11

 -- Christian Marillat <marillat@debian.org>  Sun, 04 Mar 2018 11:53:49 +0100
