=== debian/control ===
Source: cmark
Section: text
Priority: optional
Maintainer: Peter Eisentraut <petere@debian.org>
Homepage: https://github.com/jgm/cmark
Standards-Version: 4.1.4
Build-Depends: debhelper (>= 11), python3, cmake

Package: cmark
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: CommonMark parsing and rendering program
 cmark is the C reference implementation of CommonMark, a rationalized
 version of Markdown syntax with a spec. This package provides a
 command-line program (cmark) for parsing and rendering CommonMark
 documents.

Package: libcmark0
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: CommonMark parsing and rendering library
 cmark is the C reference implementation of CommonMark, a rationalized
 version of Markdown syntax with a spec. This package provides a library
 for parsing and rendering CommonMark documents.
 .
 This package contains the shared libraries.

Package: libcmark-dev
Architecture: any
Section: libdevel
Depends: libcmark0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: development files for CommonMark parsing and rendering library
 cmark is the C reference implementation of CommonMark, a rationalized
 version of Markdown syntax with a spec. This package provides a library
 for parsing and rendering CommonMark documents.
 .
 This package contains the header and development files.
