=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%cmark-$1.tar.gz%" \
    https://github.com/jgm/cmark/releases \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
