=== debian/changelog ===
cmark (0.29.0-2) unstable; urgency=medium

  * declare compliance with Debian Policy 4.5.0
  * use debhelper compatibility level 12 (not 11);
    build-depend on debhelper-compat (not debhelper)
  * add patch cherry-picked upstream
    to use html.escape instead of cgi.escape in normalize test,
    fixing FTBFS;
    closes: 954541, thanks to Lucas Nussbaum and Hubert Chathi
  * mark lib* packages Multi-Arch: same

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 30 Mar 2020 19:06:19 +0200

cmark (0.29.0-1) unstable; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * adopt package;
    closes: bug#948229, thanks to Peter Eisentraut
  * add git-buildpackage settings:
    + use pristine-tar and signed tags
    + avoid any .git files
    + use DEP-14 branch name
  * update watch file:
    + add usage note
    + use template strings
  * Add Vcs-* fields: use salsa debian team to track packaging source
  * set Rules-Requires-Root: no
  * add patch 1001 to use multiarch install paths;
    closes: bug#950807, thanks to Helmut Grohne
  * let dh_installman handle manpage install
  * fix rename library package to include full unstable API
  * modernize debhelper: override dh_missing
    (and drop global option --fail-missing)
  * fix include license fulltext for CC-BY-SA-4.0 in debian/copyright

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 11 Feb 2020 03:14:09 +0100
