=== debian/control ===
Source: cmark
Section: text
Priority: optional
Maintainer: Jonas Smedegaard <dr@jones.dk>
Homepage: https://github.com/jgm/cmark
Standards-Version: 4.5.0
Vcs-Git: https://salsa.debian.org/debian/cmark.git
Vcs-Browser: https://salsa.debian.org/debian/cmark
Rules-Requires-Root: no
Build-Depends:
 cmake,
 debhelper-compat (= 12),
 python3,

Package: cmark
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: CommonMark parsing and rendering program
 cmark is the C reference implementation of CommonMark, a rationalized
 version of Markdown syntax with a spec. This package provides a
 command-line program (cmark) for parsing and rendering CommonMark
 documents.

Package: libcmark0.29.0
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: CommonMark parsing and rendering library
 cmark is the C reference implementation of CommonMark, a rationalized
 version of Markdown syntax with a spec. This package provides a library
 for parsing and rendering CommonMark documents.
 .
 This package contains the shared libraries.

Package: libcmark-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libcmark0.29.0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: development files for CommonMark parsing and rendering library
 cmark is the C reference implementation of CommonMark, a rationalized
 version of Markdown syntax with a spec. This package provides a library
 for parsing and rendering CommonMark documents.
 .
 This package contains the header and development files.
