=== debian/rules ===
#!/usr/bin/make -f

DH_OPTIONS = -O--buildsystem=cmake

override_dh_auto_install:
	dh_auto_install -- \
	INSTALL_PREFIX=/usr

override_dh_missing:
	dh_missing --fail-missing

%:
	dh $@ $(DH_OPTIONS:-O%=%)
